Index: trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/optimization.cs
===================================================================
--- trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.1.0/ALGLIB-3.1.0/optimization.cs	(revision 6866)
+++ trunk/sources/HeuristicLab.ExtLibs/HeuristicLab.ALGLIB/3.4.0/ALGLIB-3.4.0/optimization.cs	(revision 7294)
@@ -748,161 +2680,4 @@
 
     /*************************************************************************
-                    IMPROVED LEVENBERG-MARQUARDT METHOD FOR
-                     NON-LINEAR LEAST SQUARES OPTIMIZATION
-
-    DESCRIPTION:
-    This function is used to find minimum of function which is represented  as
-    sum of squares:
-        F(x) = f[0]^2(x[0],...,x[n-1]) + ... + f[m-1]^2(x[0],...,x[n-1])
-    using:
-    * value of function vector f[]
-    * value of Jacobian of f[]
-    * gradient of merit function F(x)
-
-    This function creates optimizer which uses acceleration strategy 2.  Cheap
-    gradient of merit function (which is twice the product of function  vector
-    and Jacobian) is used for accelerated iterations (see User Guide for  more
-    info on this subject).
-
-    REQUIREMENTS:
-    This algorithm will request following information during its operation:
-
-    * function vector f[] at given point X
-    * function vector f[] and Jacobian of f[] (simultaneously) at given point
-    * gradient of
-
-    There are several overloaded versions of  MinLMOptimize()  function  which
-    correspond  to  different LM-like optimization algorithms provided by this
-    unit. You should choose version which accepts  fvec(),  jac()  and  grad()
-    callbacks. First one is used to calculate f[] at given point,  second  one
-    calculates f[] and Jacobian df[i]/dx[j], last one calculates  gradient  of
-    merit function F(x).
-
-    You can try to initialize MinLMState structure with VJ  function and  then
-    use incorrect version  of  MinLMOptimize()  (for  example,  version  which
-    works  with  general  form function and does not provide Jacobian), but it
-    will  lead  to  exception  being  thrown  after first attempt to calculate
-    Jacobian.
-
-
-    USAGE:
-    1. User initializes algorithm state with MinLMCreateVGJ() call
-    2. User tunes solver parameters with MinLMSetCond(),  MinLMSetStpMax() and
-       other functions
-    3. User calls MinLMOptimize() function which  takes algorithm  state   and
-       callback functions.
-    4. User calls MinLMResults() to get solution
-    5. Optionally, user may call MinLMRestartFrom() to solve  another  problem
-       with same N/M but another starting point and/or another function.
-       MinLMRestartFrom() allows to reuse already initialized structure.
-
-
-    INPUT PARAMETERS:
-        N       -   dimension, N>1
-                    * if given, only leading N elements of X are used
-                    * if not given, automatically determined from size of X
-        M       -   number of functions f[i]
-        X       -   initial solution, array[0..N-1]
-
-    OUTPUT PARAMETERS:
-        State   -   structure which stores algorithm state
-
-    NOTES:
-    1. you may tune stopping conditions with MinLMSetCond() function
-    2. if target function contains exp() or other fast growing functions,  and
-       optimization algorithm makes too large steps which leads  to  overflow,
-       use MinLMSetStpMax() function to bound algorithm's steps.
-
-      -- ALGLIB --
-         Copyright 30.03.2009 by Bochkanov Sergey
-    *************************************************************************/
-    public static void minlmcreatevgj(int n, int m, double[] x, out minlmstate state)
-    {
-        state = new minlmstate();
-        minlm.minlmcreatevgj(n, m, x, state.innerobj);
-        return;
-    }
-    public static void minlmcreatevgj(int m, double[] x, out minlmstate state)
-    {
-        int n;
-
-        state = new minlmstate();
-        n = ap.len(x);
-        minlm.minlmcreatevgj(n, m, x, state.innerobj);
-
-        return;
-    }
-
-    /*************************************************************************
-                       LEVENBERG-MARQUARDT-LIKE METHOD FOR
-                      NON-LINEAR LEAST SQUARES OPTIMIZATION
-
-    DESCRIPTION:
-
-    This function is used to find minimum of function which is represented  as
-    sum of squares:
-        F(x) = f[0]^2(x[0],...,x[n-1]) + ... + f[m-1]^2(x[0],...,x[n-1])
-    using value of F(), gradient of F(), function vector f[]  and  Jacobian of
-    f[].
-
-    This function is considered obsolete since ALGLIB 3.1.0 and is present for
-    backward  compatibility  only.  We  recommend to use MinLMCreateVGJ, which
-    provides similar, but more consistent interface.
-
-      -- ALGLIB --
-         Copyright 30.03.2009 by Bochkanov Sergey
-    *************************************************************************/
-    public static void minlmcreatefgj(int n, int m, double[] x, out minlmstate state)
-    {
-        state = new minlmstate();
-        minlm.minlmcreatefgj(n, m, x, state.innerobj);
-        return;
-    }
-    public static void minlmcreatefgj(int m, double[] x, out minlmstate state)
-    {
-        int n;
-
-        state = new minlmstate();
-        n = ap.len(x);
-        minlm.minlmcreatefgj(n, m, x, state.innerobj);
-
-        return;
-    }
-
-    /*************************************************************************
-        CLASSIC LEVENBERG-MARQUARDT METHOD FOR NON-LINEAR OPTIMIZATION
-
-    DESCRIPTION:
-    This function is used to find minimum of function which is represented  as
-    sum of squares:
-        F(x) = f[0]^2(x[0],...,x[n-1]) + ... + f[m-1]^2(x[0],...,x[n-1])
-    using  value  of  F(),  function  vector  f[] and Jacobian of f[]. Classic
-    Levenberg-Marquardt method is used.
-
-    This function is considered obsolete since ALGLIB 3.1.0 and is present for
-    backward  compatibility  only.  We  recommend  to use MinLMCreateVJ, which
-    provides similar, but more consistent and feature-rich interface.
-
-      -- ALGLIB --
-         Copyright 30.03.2009 by Bochkanov Sergey
-    *************************************************************************/
-    public static void minlmcreatefj(int n, int m, double[] x, out minlmstate state)
-    {
-        state = new minlmstate();
-        minlm.minlmcreatefj(n, m, x, state.innerobj);
-        return;
-    }
-    public static void minlmcreatefj(int m, double[] x, out minlmstate state)
-    {
-        int n;
-
-        state = new minlmstate();
-        n = ap.len(x);
-        minlm.minlmcreatefj(n, m, x, state.innerobj);
-
-        return;
-    }
-
-    /*************************************************************************
     This function sets stopping conditions for Levenberg-Marquardt optimization
     algorithm.
@@ -912,6 +2687,9 @@
         EpsG    -   >=0
                     The  subroutine  finishes  its  work   if   the  condition
-                    ||G||<EpsG is satisfied, where ||.|| means Euclidian norm,
-                    G - gradient.
+                    |v|<EpsG is satisfied, where:
+                    * |.| means Euclidian norm
+                    * v - scaled gradient vector, v[i]=g[i]*s[i]
+                    * g - gradient
+                    * s - scaling coefficients set by MinLMSetScale()
         EpsF    -   >=0
                     The  subroutine  finishes  its work if on k+1-th iteration
@@ -920,5 +2698,9 @@
         EpsX    -   >=0
                     The subroutine finishes its work if  on  k+1-th  iteration
-                    the condition |X(k+1)-X(k)| <= EpsX is fulfilled.
+                    the condition |v|<=EpsX is fulfilled, where:
+                    * |.| means Euclidian norm
+                    * v - scaled step vector, v[i]=dx[i]/s[i]
+                    * dx - ste pvector, dx=X(k+1)-X(k)
+                    * s - scaling coefficients set by MinLMSetScale()
         MaxIts  -   maximum number of iterations. If MaxIts=0, the  number  of
                     iterations   is    unlimited.   Only   Levenberg-Marquardt
@@ -986,4 +2768,73 @@
 
         minlm.minlmsetstpmax(state.innerobj, stpmax);
+        return;
+    }
+
+    /*************************************************************************
+    This function sets scaling coefficients for LM optimizer.
+
+    ALGLIB optimizers use scaling matrices to test stopping  conditions  (step
+    size and gradient are scaled before comparison with tolerances).  Scale of
+    the I-th variable is a translation invariant measure of:
+    a) "how large" the variable is
+    b) how large the step should be to make significant changes in the function
+
+    Generally, scale is NOT considered to be a form of preconditioner.  But LM
+    optimizer is unique in that it uses scaling matrix both  in  the  stopping
+    condition tests and as Marquardt damping factor.
+
+    Proper scaling is very important for the algorithm performance. It is less
+    important for the quality of results, but still has some influence (it  is
+    easier  to  converge  when  variables  are  properly  scaled, so premature
+    stopping is possible when very badly scalled variables are  combined  with
+    relaxed stopping conditions).
+
+    INPUT PARAMETERS:
+        State   -   structure stores algorithm state
+        S       -   array[N], non-zero scaling coefficients
+                    S[i] may be negative, sign doesn't matter.
+
+      -- ALGLIB --
+         Copyright 14.01.2011 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minlmsetscale(minlmstate state, double[] s)
+    {
+
+        minlm.minlmsetscale(state.innerobj, s);
+        return;
+    }
+
+    /*************************************************************************
+    This function sets boundary constraints for LM optimizer
+
+    Boundary constraints are inactive by default (after initial creation).
+    They are preserved until explicitly turned off with another SetBC() call.
+
+    INPUT PARAMETERS:
+        State   -   structure stores algorithm state
+        BndL    -   lower bounds, array[N].
+                    If some (all) variables are unbounded, you may specify
+                    very small number or -INF (latter is recommended because
+                    it will allow solver to use better algorithm).
+        BndU    -   upper bounds, array[N].
+                    If some (all) variables are unbounded, you may specify
+                    very large number or +INF (latter is recommended because
+                    it will allow solver to use better algorithm).
+
+    NOTE 1: it is possible to specify BndL[i]=BndU[i]. In this case I-th
+    variable will be "frozen" at X[i]=BndL[i]=BndU[i].
+
+    NOTE 2: this solver has following useful properties:
+    * bound constraints are always satisfied exactly
+    * function is evaluated only INSIDE area specified by bound constraints
+      or at its boundary
+
+      -- ALGLIB --
+         Copyright 14.01.2011 by Bochkanov Sergey
+    *************************************************************************/
+    public static void minlmsetbc(minlmstate state, double[] bndl, double[] bndu)
+    {
+
+        minlm.minlmsetbc(state.innerobj, bndl, bndu);
         return;
     }
@@ -1000,6 +2851,4 @@
       settings: about 3 iterations - when we have analytic Jacobian, up to 2*N
       iterations - when we use finite differences to calculate Jacobian.
-    * AccType=2, after quadratic model is built and LM step is made, we use it
-      as preconditioner for several (5-10) iterations of L-BFGS algorithm.
 
     AccType=1 is recommended when Jacobian  calculation  cost  is  prohibitive
@@ -1009,9 +2858,4 @@
     approximation takes too much time to compute.
 
-    AccType=2 is recommended when Jacobian is cheap - much more  cheaper  than
-    one  Cholesky  factorization.   We   can   reduce   number   of   Cholesky
-    factorizations at the cost of increased number of  Jacobian  calculations.
-    Sometimes it helps.
-
     Table below list  optimization  protocols  (XYZ  protocol  corresponds  to
     MinLMCreateXYZ) and acceleration types they support (and use by  default).
@@ -1019,21 +2863,15 @@
     ACCELERATION TYPES SUPPORTED BY OPTIMIZATION PROTOCOLS:
 
-    protocol    0   1   2   comment
+    protocol    0   1   comment
     V           +   +
-    VJ          +   +   +
-    FGH         +       +
-    VGJ         +   +   +   special protocol, not for widespread use
-    FJ          +       +   obsolete protocol, not recommended
-    FGJ         +       +   obsolete protocol, not recommended
+    VJ          +   +
+    FGH         +
 
     DAFAULT VALUES:
 
-    protocol    0   1   2   comment
-    V               x       without acceleration it is so slooooooooow
+    protocol    0   1   comment
+    V               x   without acceleration it is so slooooooooow
     VJ          x
     FGH         x
-    VGJ                 x   we've implicitly turned (2) by passing gradient
-    FJ          x           obsolete protocol, not recommended
-    FGJ                 x   obsolete protocol, not recommended
 
     NOTE: this  function should be called before optimization. Attempt to call
@@ -1317,124 +3155,25 @@
     }
 
-}
-public partial class alglib
-{
-
-
     /*************************************************************************
-
+    This is obsolete function.
+
+    Since ALGLIB 3.3 it is equivalent to MinLMCreateVJ().
+
+      -- ALGLIB --
+         Copyright 30.03.2009 by Bochkanov Sergey
     *************************************************************************/
-    public class mincgstate
+    public static void minlmcreatevgj(int n, int m, double[] x, out minlmstate state)
     {
-        //
-        // Public declarations
-        //
-        public bool needfg { get { return _innerobj.needfg; } set { _innerobj.needfg = value; } }
-        public bool xupdated { get { return _innerobj.xupdated; } set { _innerobj.xupdated = value; } }
-        public double f { get { return _innerobj.f; } set { _innerobj.f = value; } }
-        public double[] g { get { return _innerobj.g; } }
-        public double[] x { get { return _innerobj.x; } }
-
-        public mincgstate()
-        {
-            _innerobj = new mincg.mincgstate();
-        }
-
-        //
-        // Although some of declarations below are public, you should not use them
-        // They are intended for internal use only
-        //
-        private mincg.mincgstate _innerobj;
-        public mincg.mincgstate innerobj { get { return _innerobj; } }
-        public mincgstate(mincg.mincgstate obj)
-        {
-            _innerobj = obj;
-        }
-    }
-
-
-    /*************************************************************************
-
-    *************************************************************************/
-    public class mincgreport
-    {
-        //
-        // Public declarations
-        //
-        public int iterationscount { get { return _innerobj.iterationscount; } set { _innerobj.iterationscount = value; } }
-        public int nfev { get { return _innerobj.nfev; } set { _innerobj.nfev = value; } }
-        public int terminationtype { get { return _innerobj.terminationtype; } set { _innerobj.terminationtype = value; } }
-
-        public mincgreport()
-        {
-            _innerobj = new mincg.mincgreport();
-        }
-
-        //
-        // Although some of declarations below are public, you should not use them
-        // They are intended for internal use only
-        //
-        private mincg.mincgreport _innerobj;
-        public mincg.mincgreport innerobj { get { return _innerobj; } }
-        public mincgreport(mincg.mincgreport obj)
-        {
-            _innerobj = obj;
-        }
-    }
-
-    /*************************************************************************
-            NONLINEAR CONJUGATE GRADIENT METHOD
-
-    DESCRIPTION:
-    The subroutine minimizes function F(x) of N arguments by using one of  the
-    nonlinear conjugate gradient methods.
-
-    These CG methods are globally convergent (even on non-convex functions) as
-    long as grad(f) is Lipschitz continuous in  a  some  neighborhood  of  the
-    L = { x : f(x)<=f(x0) }.
-
-
-    REQUIREMENTS:
-    Algorithm will request following information during its operation:
-    * function value F and its gradient G (simultaneously) at given point X
-
-
-    USAGE:
-    1. User initializes algorithm state with MinCGCreate() call
-    2. User tunes solver parameters with MinCGSetCond(), MinCGSetStpMax() and
-       other functions
-    3. User calls MinCGOptimize() function which takes algorithm  state   and
-       pointer (delegate, etc.) to callback function which calculates F/G.
-    4. User calls MinCGResults() to get solution
-    5. Optionally, user may call MinCGRestartFrom() to solve another  problem
-       with same N but another starting point and/or another function.
-       MinCGRestartFrom() allows to reuse already initialized structure.
-
-
-    INPUT PARAMETERS:
-        N       -   problem dimension, N>0:
-                    * if given, only leading N elements of X are used
-                    * if not given, automatically determined from size of X
-        X       -   starting point, array[0..N-1].
-
-    OUTPUT PARAMETERS:
-        State   -   structure which stores algorithm state
-
-      -- ALGLIB --
-         Copyright 25.03.2010 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mincgcreate(int n, double[] x, out mincgstate state)
-    {
-        state = new mincgstate();
-        mincg.mincgcreate(n, x, state.innerobj);
+        state = new minlmstate();
+        minlm.minlmcreatevgj(n, m, x, state.innerobj);
         return;
     }
-    public static void mincgcreate(double[] x, out mincgstate state)
+    public static void minlmcreatevgj(int m, double[] x, out minlmstate state)
     {
         int n;
 
-        state = new mincgstate();
+        state = new minlmstate();
         n = ap.len(x);
-        mincg.mincgcreate(n, x, state.innerobj);
+        minlm.minlmcreatevgj(n, m, x, state.innerobj);
 
         return;
@@ -1442,219 +3181,50 @@
 
     /*************************************************************************
-    This function sets stopping conditions for CG optimization algorithm.
-
-    INPUT PARAMETERS:
-        State   -   structure which stores algorithm state
-        EpsG    -   >=0
-                    The  subroutine  finishes  its  work   if   the  condition
-                    ||G||<EpsG is satisfied, where ||.|| means Euclidian norm,
-                    G - gradient.
-        EpsF    -   >=0
-                    The  subroutine  finishes  its work if on k+1-th iteration
-                    the  condition  |F(k+1)-F(k)|<=EpsF*max{|F(k)|,|F(k+1)|,1}
-                    is satisfied.
-        EpsX    -   >=0
-                    The subroutine finishes its work if  on  k+1-th  iteration
-                    the condition |X(k+1)-X(k)| <= EpsX is fulfilled.
-        MaxIts  -   maximum number of iterations. If MaxIts=0, the  number  of
-                    iterations is unlimited.
-
-    Passing EpsG=0, EpsF=0, EpsX=0 and MaxIts=0 (simultaneously) will lead to
-    automatic stopping criterion selection (small EpsX).
+    This is obsolete function.
+
+    Since ALGLIB 3.3 it is equivalent to MinLMCreateFJ().
 
       -- ALGLIB --
-         Copyright 02.04.2010 by Bochkanov Sergey
+         Copyright 30.03.2009 by Bochkanov Sergey
     *************************************************************************/
-    public static void mincgsetcond(mincgstate state, double epsg, double epsf, double epsx, int maxits)
+    public static void minlmcreatefgj(int n, int m, double[] x, out minlmstate state)
     {
-
-        mincg.mincgsetcond(state.innerobj, epsg, epsf, epsx, maxits);
+        state = new minlmstate();
+        minlm.minlmcreatefgj(n, m, x, state.innerobj);
         return;
     }
-
-    /*************************************************************************
-    This function turns on/off reporting.
-
-    INPUT PARAMETERS:
-        State   -   structure which stores algorithm state
-        NeedXRep-   whether iteration reports are needed or not
-
-    If NeedXRep is True, algorithm will call rep() callback function if  it is
-    provided to MinCGOptimize().
-
-      -- ALGLIB --
-         Copyright 02.04.2010 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mincgsetxrep(mincgstate state, bool needxrep)
+    public static void minlmcreatefgj(int m, double[] x, out minlmstate state)
     {
-
-        mincg.mincgsetxrep(state.innerobj, needxrep);
+        int n;
+
+        state = new minlmstate();
+        n = ap.len(x);
+        minlm.minlmcreatefgj(n, m, x, state.innerobj);
+
         return;
     }
 
     /*************************************************************************
-    This function sets CG algorithm.
-
-    INPUT PARAMETERS:
-        State   -   structure which stores algorithm state
-        CGType  -   algorithm type:
-                    * -1    automatic selection of the best algorithm
-                    * 0     DY (Dai and Yuan) algorithm
-                    * 1     Hybrid DY-HS algorithm
+    This function is considered obsolete since ALGLIB 3.1.0 and is present for
+    backward  compatibility  only.  We  recommend  to use MinLMCreateVJ, which
+    provides similar, but more consistent and feature-rich interface.
 
       -- ALGLIB --
-         Copyright 02.04.2010 by Bochkanov Sergey
+         Copyright 30.03.2009 by Bochkanov Sergey
     *************************************************************************/
-    public static void mincgsetcgtype(mincgstate state, int cgtype)
+    public static void minlmcreatefj(int n, int m, double[] x, out minlmstate state)
     {
-
-        mincg.mincgsetcgtype(state.innerobj, cgtype);
+        state = new minlmstate();
+        minlm.minlmcreatefj(n, m, x, state.innerobj);
         return;
     }
-
-    /*************************************************************************
-    This function sets maximum step length
-
-    INPUT PARAMETERS:
-        State   -   structure which stores algorithm state
-        StpMax  -   maximum step length, >=0. Set StpMax to 0.0,  if you don't
-                    want to limit step length.
-
-    Use this subroutine when you optimize target function which contains exp()
-    or  other  fast  growing  functions,  and optimization algorithm makes too
-    large  steps  which  leads  to overflow. This function allows us to reject
-    steps  that  are  too  large  (and  therefore  expose  us  to the possible
-    overflow) without actually calculating function value at the x+stp*d.
-
-      -- ALGLIB --
-         Copyright 02.04.2010 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mincgsetstpmax(mincgstate state, double stpmax)
+    public static void minlmcreatefj(int m, double[] x, out minlmstate state)
     {
-
-        mincg.mincgsetstpmax(state.innerobj, stpmax);
-        return;
-    }
-
-    /*************************************************************************
-    This function provides reverse communication interface
-    Reverse communication interface is not documented or recommended to use.
-    See below for functions which provide better documented API
-    *************************************************************************/
-    public static bool mincgiteration(mincgstate state)
-    {
-
-        bool result = mincg.mincgiteration(state.innerobj);
-        return result;
-    }
-    /*************************************************************************
-    This family of functions is used to launcn iterations of nonlinear optimizer
-
-    These functions accept following parameters:
-        grad    -   callback which calculates function (or merit function)
-                    value func and gradient grad at given point x
-        rep     -   optional callback which is called after each iteration
-                    can be null
-        obj     -   optional object which is passed to func/grad/hess/jac/rep
-                    can be null
-
-
-      -- ALGLIB --
-         Copyright 20.04.2009 by Bochkanov Sergey
-
-    *************************************************************************/
-    public static void mincgoptimize(mincgstate state, ndimensional_grad grad, ndimensional_rep rep, object obj)
-    {
-        if( grad==null )
-            throw new alglibexception("ALGLIB: error in 'mincgoptimize()' (grad is null)");
-        while( alglib.mincgiteration(state) )
-        {
-            if( state.needfg )
-            {
-                grad(state.x, ref state.innerobj.f, state.innerobj.g, obj);
-                continue;
-            }
-            if( state.innerobj.xupdated )
-            {
-                if( rep!=null )
-                    rep(state.innerobj.x, state.innerobj.f, obj);
-                continue;
-            }
-            throw new alglibexception("ALGLIB: error in 'mincgoptimize' (some derivatives were not provided?)");
-        }
-    }
-
-
-
-    /*************************************************************************
-    Conjugate gradient results
-
-    INPUT PARAMETERS:
-        State   -   algorithm state
-
-    OUTPUT PARAMETERS:
-        X       -   array[0..N-1], solution
-        Rep     -   optimization report:
-                    * Rep.TerminationType completetion code:
-                        * -2    rounding errors prevent further improvement.
-                                X contains best point found.
-                        * -1    incorrect parameters were specified
-                        *  1    relative function improvement is no more than
-                                EpsF.
-                        *  2    relative step is no more than EpsX.
-                        *  4    gradient norm is no more than EpsG
-                        *  5    MaxIts steps was taken
-                        *  7    stopping conditions are too stringent,
-                                further improvement is impossible
-                    * Rep.IterationsCount contains iterations count
-                    * NFEV countains number of function calculations
-
-      -- ALGLIB --
-         Copyright 20.04.2009 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mincgresults(mincgstate state, out double[] x, out mincgreport rep)
-    {
-        x = new double[0];
-        rep = new mincgreport();
-        mincg.mincgresults(state.innerobj, ref x, rep.innerobj);
-        return;
-    }
-
-    /*************************************************************************
-    Conjugate gradient results
-
-    Buffered implementation of MinCGResults(), which uses pre-allocated buffer
-    to store X[]. If buffer size is  too  small,  it  resizes  buffer.  It  is
-    intended to be used in the inner cycles of performance critical algorithms
-    where array reallocation penalty is too large to be ignored.
-
-      -- ALGLIB --
-         Copyright 20.04.2009 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mincgresultsbuf(mincgstate state, ref double[] x, mincgreport rep)
-    {
-
-        mincg.mincgresultsbuf(state.innerobj, ref x, rep.innerobj);
-        return;
-    }
-
-    /*************************************************************************
-    This  subroutine  restarts  CG  algorithm from new point. All optimization
-    parameters are left unchanged.
-
-    This  function  allows  to  solve multiple  optimization  problems  (which
-    must have same number of dimensions) without object reallocation penalty.
-
-    INPUT PARAMETERS:
-        State   -   structure used to store algorithm state.
-        X       -   new starting point.
-
-      -- ALGLIB --
-         Copyright 30.07.2010 by Bochkanov Sergey
-    *************************************************************************/
-    public static void mincgrestartfrom(mincgstate state, double[] x)
-    {
-
-        mincg.mincgrestartfrom(state.innerobj, x);
+        int n;
+
+        state = new minlmstate();
+        n = ap.len(x);
+        minlm.minlmcreatefj(n, m, x, state.innerobj);
+
         return;
     }
@@ -1681,5 +3251,5 @@
         public minasastate()
         {
-            _innerobj = new minasa.minasastate();
+            _innerobj = new mincomp.minasastate();
         }
 
@@ -1688,7 +3258,7 @@
         // They are intended for internal use only
         //
-        private minasa.minasastate _innerobj;
-        public minasa.minasastate innerobj { get { return _innerobj; } }
-        public minasastate(minasa.minasastate obj)
+        private mincomp.minasastate _innerobj;
+        public mincomp.minasastate innerobj { get { return _innerobj; } }
+        public minasastate(mincomp.minasastate obj)
         {
             _innerobj = obj;
@@ -1712,5 +3282,5 @@
         public minasareport()
         {
-            _innerobj = new minasa.minasareport();
+            _innerobj = new mincomp.minasareport();
         }
 
@@ -1719,7 +3289,7 @@
         // They are intended for internal use only
         //
-        private minasa.minasareport _innerobj;
-        public minasa.minasareport innerobj { get { return _innerobj; } }
-        public minasareport(minasa.minasareport obj)
+        private mincomp.minasareport _innerobj;
+        public mincomp.minasareport innerobj { get { return _innerobj; } }
+        public minasareport(mincomp.minasareport obj)
         {
             _innerobj = obj;
